<template>
  <div class="history">
    <div class="upper-area d-flex align-items-center">
      <div class="title mr-auto">
        {{ $t('deposit.history.header') }}
      </div>
    </div>

    <div class="content">
      <template v-if="transactions.length > 0">
        <div class="deposit d-flex align-items-center" v-for="(transaction, index) in transactions" :class="{ 'white-bg' : (index % 2 != 0) }" @click="openDetailTransaction(transaction)">
          <div class="left mr-auto">
            <span class="coin">{{ transaction.currency }}</span>
            <span class="value">{{ transaction.amount | formatCurrencyAmount(transaction.currency, '0') }}</span>
            <br>
            <span class="datetime">{{ formatDate(transaction) }}</span>
          </div>
          <div class="right status" :class="transaction.status">
            {{ transaction | transactionStatus }}
          </div>
        </div>
      </template>
      <template v-else>
        <div class="not-found">
          <span class="iconmo-not-found not-found__icon"></span>
          <span class="not-found__text">{{ $t('deposit.not_found_text') }}</span>
        </div>
      </template>
    </div>
  </div>
</template>

<script>
import { mapState } from 'vuex';
import moment from 'moment';

import rf from '../../common/requests/RequestFactory';
import DetailTransaction from '../components/Modal/DetailTransaction.vue';

export default {
  data () {
    return {
      transactions: [],
      exportUrl: '',
    };
  },
  computed: {
    ...mapState([
      'user',
    ]),
  },
  methods: {
    async getDepositTransactions () {
      if (this.user) {
        const res = await rf.getRequest('WalletRequest').getTransactions();
        this.transactions = [...res.data];
      }
    },
    formatDate (transaction) {
      return moment(transaction.created_at).format('YYYY-MM-DD HH:mm:ss');
    },
    openDetailTransaction (transaction) {
      this.$broadcast('open-modal', DetailTransaction, {transaction});
    },
  },
  watch: {
    user () {
      this.getDepositTransactions();
    },
  },
  created () {
    this.$on('TransactionUpdated', () => {
      this.getDepositTransactions();
    });
    this.getDepositTransactions();
  },
};
</script>

<style lang="scss" scoped>
  @import "../../../sass/mobile/typoVariables.scss";
  .history {
    background: $bg_primary;
  }

  .upper-area {
    background-image: linear-gradient(to bottom, $midnight, $catalina_blue);
    box-shadow: 0 2rem 40rem 0 rgba(0, 0, 0, 0.5);
    .title {
      font-size: 18rem;
      color: $white;
      padding: 13rem 0 13rem 12rem;
      width: 240rem;
    }
  }

  .content {
    padding-top: $sz-3;
    padding-bottom: 100rem;
    .white-bg {
      background-color: #ffffff;
    }
    .deposit {
      padding: 0 $medium;
      height: 55rem;
      .coin,
      .value {
        text-transform: uppercase;
        font-size: $small;
        font-weight: bold;
        color: #1c1c1c;
      }
      .value {
        margin-left: $sz-2;
      }
      .datetime {
        font-size: $small;
        color: #989898;
      }
      .status {
        height: 55rem;
        padding-top: 6rem;
        font-size: $small;
        text-transform: capitalize;
        &.waiting {
          color: #4a90e2;
        }
        &.confirming {
          color: #4caf50;
        }
        &.succeeded {
          color: #fa7300;
        }
        &.failed {
          color: #d0021b;
        }
      }
    }
  }

  .not-found {
    margin-top: 18rem;
    text-align: center;
    .not-found__icon {
      padding: 20rem;
      background-color: $white;
      border-radius: 50%;
      font-size: 90rem;
      display: inline-block;
      margin-bottom: 8rem;
    }

    .not-found__text {
      display: block;
      font-size: $small;
      color: $thin_gray;
    }
  }
</style>
